#include <3664F.H>
#include "w7a.h"

/******************************************************/
/*VA|[goRłobƒʐM*/
/******************************************************/
unsigned char sio_comm(struct SIO *sio)
{
unsigned char	i, command, batt, touch_sw;
unsigned int	ii;

	/*ʐM֘ÃZNV*/
	command = check_sci3();
	/*obt@̂Ƃ͋A*/
	if(command == 0) return(0);

	print_c_sci3(command);/*MfB[*/

	/*ړ~*/
	if(command == '0')
	{
		/*drbo͒lj[gɂ*/
		sio->servo_data[1] = STOP_VAL;
	}

	/*sJE^NAړJn*/
	if(command == '1')
	{
		/*JE^NA*/
		TV.TCNTV = 0;

		/*^b`A{[gXCb` 1:ON / 0:OFF */
		sio->touch_abort = read_c_sci3();

		/*ړ@ԗփGR[_JEg*/
		sio->dist_move = read_c_sci3();

		/*XeAOT[{@ovlpX*/
		sio->servo_data[0] = read_ii_sci3();

		/*ANZdrb@ovlpX*/
		sio->servo_data[1] = read_ii_sci3();

		/*stOZbg*/
		sio->flg_running = 1;
	}

	/*ړԁ@M*/
	if(command == '6')
	{
		/*sԃtO*/
		print_c_sci3(sio->flg_running);

		/*sJE^iЗւ̂ݑj*/
		print_c_sci3(TV.TCNTV);
	}

	/*PSD[h*/
	if(command == '7')
	{
		read_PSD(&sio->PSD_L, &sio->PSD_R);
		print_c_sci3(sio->PSD_R);
		print_c_sci3(sio->PSD_L);
	}

	/*qbT[{f[^M*/
	if(command == 'B')
	{
		/*qbT[{֐߃f[^M*/
		/*T[{O@@T[{V̏Ńf[^󂯎*/
		for(i = 0; i < 8; i++)
		{
			ii = read_ii_sci3();
			/*0.5msecȉ̃pXɂȂf[^͖*/
			if(ii < 3720) sio->servo_data[i] = ii;
		}
	}

	/*xZT@茋ʑM*/
	if(command == 'C')
	{
		/*Pꃂ[hł`mS`Uǂݎ*/
		AD.CSR.BIT.CH = 4;/*xiEj*/
		AD.CSR.BIT.ADST = 1;
		while(AD.CSR.BIT.ADST == 1);
		ii = AD.DRA / 64;
		print_ii_sci3(ii);

		AD.CSR.BIT.CH = 5;/*wiOj*/
		AD.CSR.BIT.ADST = 1;
		while(AD.CSR.BIT.ADST == 1);
		ii = AD.DRB / 64;
		print_ii_sci3(ii);

		AD.CSR.BIT.CH = 6;/*yi㉺j*/
		AD.CSR.BIT.ADST = 1;
		while(AD.CSR.BIT.ADST == 1);
		ii = AD.DRC / 64;
		print_ii_sci3(ii);

	}

	/*^b`ZT@茋ʑM*/
	if(command == 'J')
	{
		/*^b`ZTXCb`񑗐M*/
		/*Ղ悤ɂO`R̃LN^ŕԂ*/
		touch_sw = IO.PDR1.BIT.B5 * 2 + IO.PDR1.BIT.B4 + '0';
		print_c_sci3(touch_sw);
	}

	/*XCb`M(T[{̂nm^nee)*/
	if(command == 'K')
	{
		sio->switch_servo = read_c_sci3() & 1;/* 1 or 0 servo*/
	}

	/*drd@茋ʑM*/
	if(command == 'M')
	{
		/*Pꃂ[hł`mVǂݎ*/
		AD.CSR.BIT.CH = 7;
		AD.CSR.BIT.ADST = 1;
		while(AD.CSR.BIT.ADST == 1);
		ii = AD.DRD;
		batt = (unsigned char)(ii / 256);
		print_c_sci3(batt);
	}

	/*gZT@茋ʑM*/
	if(command == 'd')
	{
		ii = read_sonic();
		print_ii_sci3(ii);
	}

	/*CRpX@茋ʑM*/
	if(command == 'f')
	{
		/*Ղ悤ɂO`ṼLN^ŕԂ*/
		i = (IO.PDR8.BYTE & 0x70) / 16 + '0';
		print_c_sci3(i);
	}

	/*Cds@茋ʑM*/
	if(command == 'g')
	{
		/*Pꃂ[hł`mRǂݎ*/
		AD.CSR.BIT.CH = 3;
		AD.CSR.BIT.ADST = 1;
		while(AD.CSR.BIT.ADST == 1);
		i = AD.DRD / 256;
		print_c_sci3(i);
	}

	/*T[~X^@茋ʑM*/
	if(command == 'j')
	{
		/*Pꃂ[hł`mQǂݎ*/
		AD.CSR.BIT.CH = 2;
		AD.CSR.BIT.ADST = 1;
		while(AD.CSR.BIT.ADST == 1);
		ii = AD.DRC / 128;
		print_ii_sci3(ii);
	}

	return(command);
}
